#include <assembleit2_64.au3>

#AutoIt3Wrapper_UseX64=n

#cs _RdRand_superfast
    Use32                                                        ;32Bit!
    rdrand eax                                                   ;store RdRand into Register
    ret
#ce

#cs _RdRand_slow
    Use32                                                        ;32Bit!
    mov ecx,11
    .loop1:
    sub ecx, 1
    jz .exit                                                     ;exit if ecx=0, 10 loops were executed
    rdrand eax                                                   ;store RdRand into Register
    jnc .loop1                                                   ;loop 10 times?
    .exit:
    ret
#ce

#cs _RdRand_available
    Use32                                                        ;32Bit!
    mov eax,1
    cpuid                                                        ;is RdRand-instruction available on your processor?
    bt ecx,30                                                    ;looking for the "yes, it is"-Bit
    mov eax,0                                                    ;exit code to AutoIt: failure
    jnc .exit                                                    ;if the Bit is not set, then exit
    mov eax,1                                                    ;exit code to AutoIt: success
    .exit:
    ret
#ce


$ret = _AssembleIt2("uint", "_RdRand_available")
If $ret = 1 Then
    $RdRand_available = "Your Processor supports the Rdrand-instruction!"
Else
    $RdRand_available = "Your Processor is not able to execute the Rdrand-instruction!"
EndIf
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $RdRand_available = ' & $RdRand_available & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console


$RdRand = _AssembleIt2("uint", "_RdRand_slow")
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $RdRand = ' & $RdRand & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console

$RdRand = _AssembleIt2("uint", "_RdRand_superfast")
ConsoleWrite('@@ Debug(' & @ScriptLineNumber & ') : $RdRand = ' & $RdRand & @CRLF & '>Error code: ' & @error & @CRLF) ;### Debug Console